"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const ControllerType_1 = __importDefault(require("../../enums/ControllerType"));
const FocuserKeyboard_1 = __importDefault(require("./FocuserKeyboard"));
const FocuserQuest2_1 = __importDefault(require("./FocuserQuest2"));
function Focuser() {
    return [FocuserMixIn];
}
exports.default = Focuser;
function FocuserMixIn(Base) {
    let CoreBase = FocuserCore(Base);
    switch (Base.controllerType) {
        case ControllerType_1.default.KEYBOARD:
            return (0, FocuserKeyboard_1.default)(CoreBase);
        case ControllerType_1.default.QUEST2:
            return (0, FocuserQuest2_1.default)(CoreBase);
    }
    return CoreBase;
}
function FocuserCore(Base) {
    class FocuserCoreMixIn extends Base {
        defaults() {
            return Object.assign(Object.assign({}, super.defaults()), { focusTargets: [] });
        }
        update(p) {
            this.focusTargets = this.project.scene.all
                .map(m => m)
                .filter(m => !!m.isFocusable);
            super.update(p);
        }
    }
    return FocuserCoreMixIn;
}
//# sourceMappingURL=Focuser.js.map