"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function GrabberKeyboard(Base) {
    class GrabberKeyboardMixIn extends Base {
        constructor() {
            super(...arguments);
            this.temp = false;
        }
        update(p) {
            var _a;
            if (!((_a = this.grabbed) === null || _a === void 0 ? void 0 : _a.length)) {
                if (this.temp) {
                    this.temp = false;
                    return;
                }
                return super.update(p);
            }
            this.drag(this.mouseDiff.clone().multiplyScalar(0.005));
            this.mouseDiff.set(0, 0);
        }
        onMouseDown(e) {
            super['onMouseDown'](e);
            this.selected
                .map(m => m)
                .filter(m => !!m.isGrabbable)
                .forEach(this.grab.bind(this));
        }
        onMouseUp(e) {
            super['onMouseUp'](e);
            this.temp = true;
            this.ungrabAll();
        }
    }
    return GrabberKeyboardMixIn;
}
exports.default = GrabberKeyboard;
//# sourceMappingURL=GrabberKeyboard.js.map