import ConstructorOf from '@thats/utils/types/ConstructorOf'
import { IGrabbable } from '../grabber/Grabbable'

export interface IResizable extends IGrabbable {
	isResizable: boolean
}

export default function Resizable<T extends IGrabbable>(
	Base: ConstructorOf<T>
): ConstructorOf<T & IResizable> {
	// eslint-disable-next-line @typescript-eslint/ban-ts-comment
	// @ts-ignore
	class ResizableMixIn extends Base {
		isResizable: boolean
	}
	return ResizableMixIn as unknown as ConstructorOf<T & IResizable>
}
