import ConstructorOf from '@thats/utils/types/ConstructorOf'
import { IGrabbable } from '../grabber/Grabbable'

export interface IRotatable extends IGrabbable {
	isRotatable: boolean
}

export default function Rotatable<T extends IGrabbable>(
	Base: ConstructorOf<T>
): ConstructorOf<T & IRotatable> {
	// eslint-disable-next-line @typescript-eslint/ban-ts-comment
	// @ts-ignore
	class RotatableMixIn extends Base {
		isRotatable: boolean
	}
	return RotatableMixIn as unknown as ConstructorOf<T & IRotatable>
}
