import ConstructorOf from '@thats/utils/types/ConstructorOf';
import { Material } from 'three';
import XRMass from '../../core/XRMass';
import { IFocusable } from '../focuser/Focusable';
export interface ISelectable extends XRMass {
    selectMaterial: Material;
    isSelectable: boolean;
    isSelected: boolean;
    select(): void;
    deselect(): void;
    onChangeSelected(v: boolean): void;
}
export default function Selectable<T extends IFocusable>(Base: ConstructorOf<T>): ConstructorOf<T & ISelectable>;
