"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const KeyCode_1 = __importDefault(require("../../enums/KeyCode"));
function WalkerKeyboard(Base) {
    class WalkerKeyboardMixIn extends Base {
        update(p) {
            const maxImpulse = this.shiftDown ? 3 : 1;
            const maxRoll = 1;
            const impulseAcc = 0.1;
            const rotateAcc = 0.1;
            const impulse = this.impulsion;
            const rotation = this.rotation;
            const mouseDiff = this.mouseDiff;
            if (this.isKeyDown(KeyCode_1.default.W))
                impulse.z = Math.max(-maxImpulse, impulse.z - impulseAcc);
            else if (impulse.z < 0)
                impulse.z = Math.min(0, impulse.z + impulseAcc);
            if (this.isKeyDown(KeyCode_1.default.S))
                impulse.z = Math.min(maxImpulse, impulse.z + impulseAcc);
            else if (impulse.z > 0)
                impulse.z = Math.max(0, impulse.z - impulseAcc);
            if (this.isKeyDown(KeyCode_1.default.A))
                impulse.x = Math.max(-maxImpulse, impulse.x - impulseAcc);
            else if (impulse.x < 0)
                impulse.x = Math.min(0, impulse.x + impulseAcc);
            if (this.isKeyDown(KeyCode_1.default.D))
                impulse.x = Math.min(maxImpulse, impulse.x + impulseAcc);
            else if (impulse.x > 0)
                impulse.x = Math.max(0, impulse.x - impulseAcc);
            if (this.isKeyDown(KeyCode_1.default.Q))
                rotation.z = Math.max(-maxRoll, rotation.z - rotateAcc);
            else if (rotation.z < 0)
                rotation.z = Math.max(0, rotation.z + rotateAcc);
            if (this.isKeyDown(KeyCode_1.default.E))
                rotation.z = Math.min(maxRoll, rotation.z + rotateAcc);
            else if (rotation.z > 0)
                rotation.z = Math.max(0, rotation.z - rotateAcc);
            rotation.y = this.mouseDown ? mouseDiff.x * rotateAcc : 0;
            rotation.x = this.mouseDown ? mouseDiff.y * rotateAcc : 0;
            super.update(p);
        }
    }
    return WalkerKeyboardMixIn;
}
exports.default = WalkerKeyboard;
//# sourceMappingURL=WalkerKeyboard.js.map