"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function WalkerQuest2(Base) {
    class WalkerQuest2MixIn extends Base {
        defaults() {
            return Object.assign({}, super.defaults());
        }
        update(p) {
            var _a, _b;
            const { z: impulseZ } = this.impulsion;
            const { y: rotationY } = this.rotation;
            const axesThreshold = 0.5;
            const maxImpulse = 1;
            const fbValue = (_a = this.left.gamepad) === null || _a === void 0 ? void 0 : _a.axes[3];
            const lrValue = (_b = this.right.gamepad) === null || _b === void 0 ? void 0 : _b.axes[2];
            const isFwd = fbValue < 0 - axesThreshold;
            const isBwd = fbValue > axesThreshold;
            const isLeft = lrValue < 0 - axesThreshold;
            const isRight = lrValue > axesThreshold;
            if (isFwd)
                this.impulsion.z = Math.max(-maxImpulse, impulseZ + fbValue);
            else if (this.impulsion.z < 0)
                this.impulsion.z = Math.min(0, impulseZ);
            if (isBwd)
                this.impulsion.z = Math.min(maxImpulse, impulseZ + fbValue);
            else if (this.impulsion.z > 0)
                this.impulsion.z = Math.max(0, impulseZ);
            if (isLeft)
                this.rotation.y = Math.min(maxImpulse, rotationY - lrValue);
            else if (this.rotation.y > 0)
                this.rotation.y = Math.min(0, rotationY);
            if (isRight)
                this.rotation.y = Math.max(-maxImpulse, rotationY - lrValue);
            else if (this.rotation.y < 0)
                this.rotation.y = Math.max(0, rotationY);
            super.update(p);
        }
    }
    return WalkerQuest2MixIn;
}
exports.default = WalkerQuest2;
//# sourceMappingURL=WalkerQuest2.js.map