import ConstructorOf from '@thats/utils/types/ConstructorOf'
import { XRFrame } from 'three'

export interface XRUpdateParams {
	time?: number
	delta?: number
	frame?: XRFrame
}

export interface IClass {
	defaults(): any
	init(): void
	update(p?: XRUpdateParams): void
	destroy(): void
}

class Empty {}

export default function XRClass<T>(Base?: ConstructorOf<T>): ConstructorOf<IClass & T> {
	// eslint-disable-next-line @typescript-eslint/ban-ts-comment
	// @ts-ignore
	class XRClassMixIn extends (Base || Empty) implements IClass {
		constructor(o: any) {
			super()
			const d = this.defaults()
			Object.assign(this, this.defaults() || {}, o || {})
			this.init()
		}
		defaults() {
			return {}
		}
		init() {}
		update(p?: XRUpdateParams) {}
		destroy() {}
	}
	return XRClassMixIn as ConstructorOf<IClass & T>
}
