import ParamType from '../enums/ParamType'
import XRClass from './XRClass'

export class XRParam<T> extends XRClass() {
	protected _value: T
	key: string
	label: string
	type: ParamType
	defaultValue: T

	get value() {
		return this._value
	}

	set value(v: T) {
		this._value = v
	}

	defaults() {
		return {
			...super.defaults(),
			label: 'Unlabled',
			key: 'key',
			type: ParamType.NUMBER,
			defaultValue: 0,
		}
	}

	init() {
		super.init()
		this.value = this.defaultValue
	}
}
export default XRParam
export type IParam = typeof XRParam
