import { Scene as TScene, Vector3 } from 'three';
import MotionType from '../enums/MotionType';
import { XRUpdateParams } from './XRClass';
import Light from './XRLight';
import XRMass from './XRMass';
import XRObject from './XRObject';
import XRParam from './XRParam';
declare const XRScene_base: import("@thats/utils/types/ConstructorOf").ConstructorOf<import("./XRClass").IClass>;
export default class XRScene extends XRScene_base {
    key: string;
    label: string;
    playerInitPosition: Vector3;
    playerInitRotation: Vector3;
    gravity: Vector3;
    params: {
        [key: string]: XRParam<any>;
    };
    controllerBehaviours: any[];
    objects: XRObject[];
    masses: XRMass[];
    lights: Light[];
    gfxScene: TScene;
    physxScene: Ammo.btSoftRigidDynamicsWorld;
    defaults(): any;
    init(): void;
    build(): void;
    update(p?: XRUpdateParams): void;
    reinit: import("lodash").DebouncedFunc<() => void>;
    setParam<T>(param: XRParam<T>, value: T): any;
    get all(): (XRMass | XRObject | Light)[];
    addLight(l: Light): void;
    addObject(o: XRObject): void;
    addMass(o: XRMass, type?: MotionType): any;
    remove(o: XRObject | XRMass | Light): void;
    destroy(fullyDestroy?: boolean): void;
}
export {};
