import XYWH from '@thats/utils/types/XYWH';
import { XRSession } from 'three';
import CameraAngle from '../enums/CameraAngle';
import { XRUpdateParams } from './XRClass';
interface BloomSettings {
    enabled: boolean;
    strength: number;
    threshold: number;
    radius: number;
}
declare const XRViewer_base: import("@thats/utils/types/ConstructorOf").ConstructorOf<import("./XRClass").IClass>;
export default class XRViewer extends XRViewer_base {
    private preDims;
    private project;
    private renderer;
    private bloomComposer;
    private finalComposer;
    private bloomLayer;
    private fullscreen;
    static vertexShader: string;
    static fragmentShader: string;
    dims: XYWH;
    el: HTMLElement;
    canvas: HTMLCanvasElement;
    shadows: boolean;
    cameraAngle: CameraAngle;
    enabled: boolean;
    bloom: BloomSettings;
    setFullscreen(on: boolean): void;
    setDims(d: XYWH): void;
    defaults(): any;
    init(): void;
    update(p?: XRUpdateParams): void;
    destroy(): void;
    setXRSession(s?: XRSession): Promise<void>;
    private renderBloom;
    _handleKeyDown: any;
    private handleKeyDown;
    private onEscapePressed;
    private onChangeFullscreen;
    private onChangeDims;
}
export {};
