import { Vector2 } from 'three'

export class MousePos {
	offset: Vector2 = new Vector2()
	client: Vector2 = new Vector2()

	constructor(e?: MouseEvent) {
		this.offset = new Vector2(e?.offsetX || 0, e?.offsetY || 0)
		this.client = new Vector2(e?.clientX || 0, e?.clientY || 0)
	}

	sub(o: MousePos) {
		const result = new MousePos()
		result.offset = this.offset.sub(o.offset)
		result.client = this.client.sub(o.client)
		return result
	}

	add(o: MousePos) {
		const result = new MousePos()
		result.offset = this.offset.add(o.offset)
		result.client = this.client.add(o.client)
		return result
	}

	multiplyScalar(v: number) {
		const result = new MousePos()
		result.offset = this.offset.multiplyScalar(v)
		result.client = this.client.multiplyScalar(v)
		return result
	}
}
