"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const three_1 = require("three");
const XRClass_1 = __importDefault(require("../core/XRClass"));
class DirectionalLight extends (0, XRClass_1.default)(three_1.DirectionalLight) {
    init() {
        super.init();
        this.shadow.mapSize.width = 2048;
        this.shadow.mapSize.height = 2048;
        const d = 50;
        this.shadow.camera.left = -d;
        this.shadow.camera.right = d;
        this.shadow.camera.top = d;
        this.shadow.camera.bottom = -d;
        this.shadow.camera.far = 3500;
    }
}
exports.default = DirectionalLight;
//# sourceMappingURL=DirectionalLight.js.map