import { DirectionalLight as TDirectionalLight } from 'three'
import XRClass from '../core/XRClass'
import XRLight from '../core/XRLight'

export default class DirectionalLight extends XRClass(TDirectionalLight) implements XRLight {
	init() {
		super.init()
		this.shadow.mapSize.width = 2048
		this.shadow.mapSize.height = 2048

		const d = 50

		this.shadow.camera.left = -d
		this.shadow.camera.right = d
		this.shadow.camera.top = d
		this.shadow.camera.bottom = -d

		this.shadow.camera.far = 3500
	}
}
