import { ConeBufferGeometry } from 'three'
import XRMass from '../core/XRMass'

export default class Cone extends XRMass {
	radius: number
	height: number
	radiusSegments: number
	heightSegments: number
	openEnded: boolean
	thetaStart: number
	thetaLength: number

	defaults() {
		return {
			...super.defaults(),
			radius: 1,
			height: 1,
			radiusSegments: 8,
			heightSegments: 1,
			openEnded: false,
			thetaStart: 0,
			thetaLength: Math.PI * 2,
		}
	}

	initGeometry() {
		this.geometry = new ConeBufferGeometry(
			this.radius,
			this.height,
			this.radiusSegments,
			this.heightSegments,
			this.openEnded,
			this.thetaStart,
			this.thetaLength
		)
	}

	growBy(v: number) {
		this.radius *= v
		this.height *= v
		this.initGeometry()
	}
}
