import { SphereBufferGeometry } from 'three'
import XRMass from '../core/XRMass'

export default class Sphere extends XRMass {
	radius: number
	widthSegments: number
	heightSegments: number
	phiStart: number
	phiLength: number
	thetaStart: number
	thetaLength: number

	defaults() {
		return {
			...super.defaults(),
			radius: 1,
			widthSegments: 16,
			heightSegments: 12,
			phiStart: 0,
			phiLength: Math.PI * 2,
			thetaStart: 0,
			thetaLength: Math.PI,
		}
	}

	initGeometry() {
		this.geometry = new SphereBufferGeometry(
			this.radius,
			this.widthSegments,
			this.heightSegments,
			this.phiStart,
			this.phiLength,
			this.thetaStart,
			this.thetaLength
		)
	}

	growBy(v: number) {
		this.radius *= v
		this.initGeometry()
	}
}
