"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const three_1 = require("three");
function applyPosQuatScaleMargin(collisionShape, pos = new three_1.Vector3(), quat = new three_1.Quaternion(), scale = new three_1.Vector3(), margin = 0.01) {
    collisionShape.setMargin(margin);
    const rotation = new Ammo.btQuaternion(0, 0, 0, 1);
    rotation.setValue(quat.x, quat.y, quat.z, quat.w);
    const localTransform = new Ammo.btTransform();
    localTransform.setIdentity();
    localTransform.getOrigin().setValue(pos.x, pos.y, pos.z);
    localTransform.setRotation(rotation);
    Ammo.destroy(rotation);
    const localScale = new Ammo.btVector3(scale.x, scale.y, scale.z);
    collisionShape.setLocalScaling(localScale);
    Ammo.destroy(localScale);
    return localTransform;
}
exports.default = applyPosQuatScaleMargin;
//# sourceMappingURL=applyPosQuatScaleMargin.js.map