import { Quaternion, Vector3 } from 'three'

export default function applyPosQuatScaleMargin(
	collisionShape: Ammo.btCollisionShape,
	pos: Vector3 = new Vector3(),
	quat: Quaternion = new Quaternion(),
	scale: Vector3 = new Vector3(),
	margin: number = 0.01
) {
	collisionShape.setMargin(margin)

	const rotation = new Ammo.btQuaternion(0, 0, 0, 1)
	rotation.setValue(quat.x, quat.y, quat.z, quat.w)

	const localTransform = new Ammo.btTransform()
	localTransform.setIdentity()
	localTransform.getOrigin().setValue(pos.x, pos.y, pos.z)
	localTransform.setRotation(rotation)
	Ammo.destroy(rotation)

	const localScale = new Ammo.btVector3(scale.x, scale.y, scale.z)
	collisionShape.setLocalScaling(localScale)
	Ammo.destroy(localScale)

	return localTransform
}
