"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function collisionShapeToRigidBody(collisionShape, localTransform, mass, disableDeactivation) {
    const motionState = new Ammo.btDefaultMotionState(localTransform);
    const localInertia = new Ammo.btVector3(0, 0, 0);
    if (mass > 0)
        collisionShape.calculateLocalInertia(mass, localInertia);
    const rbInfo = new Ammo.btRigidBodyConstructionInfo(mass, motionState, collisionShape, localInertia);
    const rigidBody = new Ammo.btRigidBody(rbInfo);
    if (mass > 0 || disableDeactivation)
        rigidBody.setActivationState(4);
    Ammo.destroy(rbInfo);
    return rigidBody;
}
exports.default = collisionShapeToRigidBody;
//# sourceMappingURL=collisionShapeToRigidBody.js.map