export default function collisionShapeToRigidBody(
	collisionShape: Ammo.btCollisionShape,
	localTransform: Ammo.btTransform,
	mass: number,
	disableDeactivation: boolean
) {
	const motionState = new Ammo.btDefaultMotionState(localTransform)
	const localInertia = new Ammo.btVector3(0, 0, 0)
	if (mass > 0) collisionShape.calculateLocalInertia(mass, localInertia)
	const rbInfo = new Ammo.btRigidBodyConstructionInfo(
		mass,
		motionState,
		collisionShape,
		localInertia
	)
	const rigidBody = new Ammo.btRigidBody(rbInfo)
	if (mass > 0 || disableDeactivation) rigidBody.setActivationState(4) // Disable deactivation
	Ammo.destroy(rbInfo)
	return rigidBody
}
