// returns the bounding box for the geometries underneath `root`.
import { Box3 } from 'three'
import iterateVertices from './iterateVertices'

export const computeBounds = function (vertices, matrices) {
	const bounds = new Box3()
	let minX = +Infinity
	let minY = +Infinity
	let minZ = +Infinity
	let maxX = -Infinity
	let maxY = -Infinity
	let maxZ = -Infinity
	bounds.min.set(0, 0, 0)
	bounds.max.set(0, 0, 0)

	iterateVertices(vertices, matrices, v => {
		if (v.x < minX) minX = v.x
		if (v.y < minY) minY = v.y
		if (v.z < minZ) minZ = v.z
		if (v.x > maxX) maxX = v.x
		if (v.y > maxY) maxY = v.y
		if (v.z > maxZ) maxZ = v.z
	})

	bounds.min.set(minX, minY, minZ)
	bounds.max.set(maxX, maxY, maxZ)
	return bounds
}
export default computeBounds
