import { Vector3 } from 'three'

export default function computeHalfExtents(
	bounds: { min: Vector3; max: Vector3 },
	minHalfExtent: number,
	maxHalfExtent: number
): Vector3 {
	const halfExtents = new Vector3()
	return halfExtents
		.subVectors(bounds.max, bounds.min)
		.multiplyScalar(0.5)
		.clampScalar(minHalfExtent, maxHalfExtent)
}
