import { Vector3 } from 'three'
import iterateVertices from './iterateVertices'

export const computeRadius = (function () {
	const center = new Vector3()
	return function (vertices, matrices, bounds) {
		let maxRadiusSq = 0
		let { x: cx, y: cy, z: cz } = bounds.getCenter(center)

		iterateVertices(vertices, matrices, v => {
			const dx = cx - v.x
			const dy = cy - v.y
			const dz = cz - v.z
			maxRadiusSq = Math.max(maxRadiusSq, dx * dx + dy * dy + dz * dz)
		})
		return Math.sqrt(maxRadiusSq)
	}
})()
export default computeRadius
