import { Matrix4, Vector3 } from 'three'
import ShapeFit from '../enums/ShapeFit'

export const computeScale = (function () {
	const matrix = new Matrix4()
	return function (matrixWorld, options: any = {}) {
		const scale = new Vector3(1, 1, 1)
		if (options.fit === ShapeFit.ALL) {
			matrix.fromArray(matrixWorld)
			scale.setFromMatrixScale(matrix)
		}
		return scale
	}
})()
export default computeScale
