"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createSphereShape = void 0;
const ShapeFit_1 = __importDefault(require("../../enums/ShapeFit"));
const ShapeType_1 = __importDefault(require("../../enums/ShapeType"));
const computeBounds_1 = __importDefault(require("../computeBounds"));
const computeRadius_1 = __importDefault(require("../computeRadius"));
const computeScale_1 = __importDefault(require("../computeScale"));
const finishCollisionShape_1 = __importDefault(require("../finishCollisionShape"));
const setDefaultOptions_1 = __importDefault(require("./setDefaultOptions"));
const createSphereShape = function (vertices, matrices, matrixWorld, options = {}) {
    options.type = ShapeType_1.default.SPHERE;
    (0, setDefaultOptions_1.default)(options);
    let radius;
    if (options.fit === ShapeFit_1.default.MANUAL && !isNaN(options.sphereRadius)) {
        radius = options.sphereRadius;
    }
    else {
        radius = (0, computeRadius_1.default)(vertices, matrices, (0, computeBounds_1.default)(vertices, matrices));
    }
    const collisionShape = new Ammo.btSphereShape(radius);
    (0, finishCollisionShape_1.default)(collisionShape, options, (0, computeScale_1.default)(matrixWorld, options));
    return collisionShape;
};
exports.createSphereShape = createSphereShape;
exports.default = exports.createSphereShape;
//# sourceMappingURL=createSphereShape.js.map