import { Euler } from 'three'
import XRObject from '../core/XRObject'
import randomVector3 from './randomVector3'

export default function randomizeRotation<T extends XRObject>(o: T, range: number): T {
	const v = randomVector3(range)
	o.setRotationFromEuler(new Euler(v.x, v.y, v.z))
	return o
}
