"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.XRSceneViewer = void 0;
const useDimensions_1 = __importDefault(require("@thatreact/core-hooks/hooks/useDimensions"));
const SXDiv_1 = __importDefault(require("@thatweb/core-mui/components/sx/SXDiv"));
const react_1 = __importDefault(require("react"));
const XRProjectViewerState_1 = require("./XRProjectViewerState");
function XRSceneViewer() {
    const { initViewer } = (0, XRProjectViewerState_1.useXRProjectViewer)();
    const [ref, dims, el] = (0, useDimensions_1.default)({ liveMeasure: true });
    const w = dims === null || dims === void 0 ? void 0 : dims.w;
    react_1.default.useEffect(() => {
        if (!w)
            return;
        initViewer(el, dims);
    }, [el, w, dims, initViewer]);
    return react_1.default.createElement(SXDiv_1.default, { sx: { flex: 1, overflow: 'hidden' }, ref: ref });
}
exports.XRSceneViewer = XRSceneViewer;
exports.default = XRSceneViewer;
//# sourceMappingURL=XRSceneViewer.js.map