import useDimensions from '@thatreact/core-hooks/hooks/useDimensions'
import SXDiv from '@thatweb/core-mui/components/sx/SXDiv'
import React from 'react'
import { useXRProjectViewer } from './XRProjectViewerState'

export function XRSceneViewer() {
	const { initViewer } = useXRProjectViewer()
	const [ref, dims, el] = useDimensions({ liveMeasure: true })

	const w = dims?.w

	React.useEffect(() => {
		if (!w) return
		initViewer(el, dims)
	}, [el, w, dims, initViewer])

	return <SXDiv sx={{ flex: 1, overflow: 'hidden' }} ref={ref} />
}
export default XRSceneViewer
